#include <iostream>
#include <sstream>

#define BOOST_INTERPROCESS_ENABLE_TIMEOUT_WHEN_LOCKING

#include <boost/interprocess/ipc/message_queue.hpp>
#include <boost/thread.hpp>

#define IPC_MSG_QUEUE_NAME "example_ipc_msg_queue_name"

int main()
{
    using namespace boost::interprocess;

    try
    {
        message_queue msg_que(open_only, IPC_MSG_QUEUE_NAME);

        for (unsigned i = 0; true; ++i)
        {
            std::cout << i << std::endl;
            std::ostringstream stream;
            stream << i;
            std::string msg = stream.str();
            boost::posix_time::time_duration td = boost::posix_time::seconds(1);
            auto waituntil = boost::posix_time::microsec_clock::universal_time() + td;
            bool sendSuccessful = msg_que.timed_send(msg.c_str(), msg.size(), 0, waituntil);
            if (! sendSuccessful) 
            {
                break;
            }
            boost::this_thread::sleep_for(boost::chrono::seconds(1));
        }
        std::cout << "Send timed out!";
    }
    catch (std::exception const& e)
    {
        std::cout << e.what() << std::endl;
    }
    catch (...)
    {
        std::cout << "Unknown exception caught." << std::endl;
    }
}
