#include <iostream>
#include <string>

#define BOOST_INTERPROCESS_ENABLE_TIMEOUT_WHEN_LOCKING

#include <boost/interprocess/ipc/message_queue.hpp>

#define IPC_MSG_QUEUE_NAME "example_ipc_msg_queue_name"

int main()
{
    using namespace boost::interprocess;

    try
    {
        std::cout << message_queue::remove(IPC_MSG_QUEUE_NAME) << std::endl;
        message_queue msg_que(create_only, IPC_MSG_QUEUE_NAME, 100, 30);

        char buf[30] = {};
        while (true)
        {
            message_queue::size_type msg_size = 0;
            unsigned unused = 0;
            msg_que.receive(buf, sizeof(buf), msg_size, unused);
            std::cout << std::string(buf, buf + msg_size) << std::endl;
        }
    }
    catch (std::exception const& e)
    {
        std::cout << e.what() << std::endl;
    }
    catch (...)
    {
        std::cout << "Unknown exception caught." << std::endl;
    }
}
